> For the complete documentation index, see [llms.txt](https://docs.petabox.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.petabox.io/http-api-compatible-with-amazon-s3/api-reference/putbucketacl.md).

# PutBucketAcl

Sets the permissions on an existing bucket using access control lists (ACL)

You can use one of the following two ways to set a bucket's permissions:

* Specify the ACL in the request body
* Specify permissions using request headers

{% hint style="warning" %}
**Note**

You cannot specify access permission using both the body and the request headers.
{% endhint %}

Depending on your application needs, you may choose to set the ACL on a bucket using either the request body or the headers. For example, if you have an existing application that updates a bucket ACL using the request body, then you can continue to use that approach.

{% hint style="danger" %}
**Important**

If your bucket uses the bucket owner enforced setting for S3 Object Ownership, ACLs are disabled and no longer affect permissions. You must use policies to grant access to your bucket and the objects in it. Requests to set ACLs or update ACLs fail and return the `AccessControlListNotSupported` error code. Requests to read ACLs are still supported.&#x20;
{% endhint %}

#### Permissions

You can set access permissions by using one of the following methods:

* Specify a canned ACL with the `x-amz-acl` request header. Petabox supports a set of predefined ACLs, known as *canned ACLs*. Each canned ACL has a predefined set of grantees and permissions. Specify the canned ACL name as the value of `x-amz-acl`. If you use this header, you cannot use other access control-specific headers in your request.&#x20;
* Specify access permissions explicitly with the `x-amz-grant-read`, `x-amz-grant-read-acp`, `x-amz-grant-write-acp`, and `x-amz-grant-full-control` headers. When using these headers, you specify explicit access permissions and grantees (Petabox accounts or Petabox groups) who will receive the permission. If you use these ACL-specific headers, you cannot use the `x-amz-acl` header to set a canned ACL. These parameters map to the set of permissions that Petabox supports in an ACL.&#x20;

You specify each grantee as a type=value pair, where the type is one of the following:

* `id` – if the value specified is the canonical user ID of a Petabox account
* `uri` – if you are granting permissions to a predefined group
* `emailAddress` – if the value specified is the email address of a Petabox account&#x20;

For example, the following `x-amz-grant-write` header grants create, overwrite, and delete objects permission to LogDelivery group predefined by Petabox and two Petabox accounts identified by their email addresses.

`x-amz-grant-write: uri="http://acs.petabox.io/groups/s3/LogDelivery", id="111122223333", id="555566667777"`

You can use either a canned ACL or specify access permissions explicitly. You cannot do both.

#### Grantee Values

You can specify the person (grantee) to whom you're assigning access rights (using request elements) in the following ways:

* By the person's ID:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="CanonicalUser"><ID><>ID<></ID><DisplayName><>GranteesEmail<></DisplayName> </Grantee>`

  DisplayName is optional and ignored in the request
* By URI:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="Group"><URI><>http://acs.petabox.io/groups/global/AuthenticatedUsers<></URI></Grantee>`
* By Email address:

  `<Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="PetaboxCustomerByEmail"><EmailAddress><>Grantees@email.com<></EmailAddress>&</Grantee>`

  The grantee is resolved to the CanonicalUser and, in a response to a GET Object acl request, appears as the CanonicalUser.

## Request Syntax <a href="#api_putbucketacl_requestsyntax" id="api_putbucketacl_requestsyntax"></a>

```http
PUT /?acl HTTP/1.1
Host: Bucket.s3.petabox.io
x-amz-acl: ACL
Content-MD5: ContentMD5
x-amz-grant-full-control: GrantFullControl
x-amz-grant-read: GrantRead
x-amz-grant-read-acp: GrantReadACP
x-amz-grant-write: GrantWrite
x-amz-grant-write-acp: GrantWriteACP
x-amz-expected-bucket-owner: ExpectedBucketOwner
<?xml version="1.0" encoding="UTF-8"?>
<AccessControlPolicy xmlns="http://s3.petabox.io/doc/2006-03-01/">
   <AccessControlList>
      <Grant>
         <Grantee>
            <DisplayName>string</DisplayName>
            <EmailAddress>string</EmailAddress>
            <ID>string</ID>
            <xsi:type>string</xsi:type>
            <URI>string</URI>
         </Grantee>
         <Permission>string</Permission>
      </Grant>
   </AccessControlList>
   <Owner>
      <DisplayName>string</DisplayName>
      <ID>string</ID>
   </Owner>
</AccessControlPolicy>
```

## URI Request Parameters <a href="#api_putbucketacl_requestparameters" id="api_putbucketacl_requestparameters"></a>

The request uses the following URI parameters.

#### Bucket

The bucket to which to apply the ACL.

Required: Yes

#### Content-MD5

The base64-encoded 128-bit MD5 digest of the data. This header must be used as a message integrity check to verify that the request body was not corrupted in transit. For more information, go to [RFC 1864.](http://www.ietf.org/rfc/rfc1864.txt)

For requests made using the Command Line Interface (CLI) or SDKs, this field is calculated automatically.

#### x-amz-acl

The canned ACL to apply to the bucket.

Valid Values: `private | public-read | public-read-write | authenticated-read`

#### x-amz-expected-bucket-owner

The account ID of the expected bucket owner. If the bucket is owned by a different account, the request fails with the HTTP status code `403 Forbidden` (access denied).

#### x-amz-grant-full-control

Allows grantee the read, write, read ACP, and write ACP permissions on the bucket.

#### x-amz-grant-read

Allows grantee to list the objects in the bucket.

#### x-amz-grant-read-acp

Allows grantee to read the bucket ACL.

#### x-amz-grant-write

Allows grantee to create new objects in the bucket.

For the bucket and object owners of existing objects, also allows deletions and overwrites of those objects.

#### x-amz-grant-write-acp

Allows grantee to write the ACL for the applicable bucket.

## Request Body <a href="#api_putbucketacl_requestbody" id="api_putbucketacl_requestbody"></a>

The request accepts the following data in XML format.

#### AccessControlPolicy

Root level tag for the AccessControlPolicy parameters.

Required: Yes

#### Grants

A list of grants.

Type: Array of Grant data types

Required: No

#### Owner

Container for the bucket owner's display name and ID.

Type: Owner data type

Required: No

## Response Syntax <a href="#api_putbucketacl_responsesyntax" id="api_putbucketacl_responsesyntax"></a>

```http
HTTP/1.1 200
```

## Response Elements <a href="#api_putbucketacl_responseelements" id="api_putbucketacl_responseelements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Examples <a href="#api_putbucketacl_examples" id="api_putbucketacl_examples"></a>

### Sample Request: Access permissions specified in the body <a href="#api_putbucketacl_example_1" id="api_putbucketacl_example_1"></a>

The following request grants access permission to the existing `examplebucket` bucket. The request specifies the ACL in the body. In addition to granting full control to the bucket owner, the XML specifies the following grants.

* Grant the `AllUsers` group READ permission on the bucket.
* Grant the `LogDelivery` group WRITE permission on the bucket.
* Grant a Petabox account, identified by email address, WRITE\_ACP permission.
* Grant a Petabox account, identified by canonical user ID, READ\_ACP permission.

```http
PUT ?acl HTTP/1.1
Host: examplebucket.s3.<Region>.petabox.io
Content-Length: 1660
x-amz-date: Thu, 12 Apr 2012 20:04:21 GMT
Authorization: authorization string

<AccessControlPolicy xmlns="http://s3.petabox.io/doc/2006-03-01/">
  <Owner>
    <ID>852b113e7a2f25102679df27bb0ae12b3f85be6BucketOwnerCanonicalUserID</ID>
    <DisplayName>OwnerDisplayName</DisplayName>
  </Owner>
  <AccessControlList>
    <Grant>
      <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="CanonicalUser">
        <ID>852b113e7a2f25102679df27bb0ae12b3f85be6BucketOwnerCanonicalUserID</ID>
        <DisplayName>OwnerDisplayName</DisplayName>
      </Grantee>
      <Permission>FULL_CONTROL</Permission>
    </Grant>
    <Grant>
      <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="Group">
        <URI xmlns="">http://acs.petabox.io/groups/global/AllUsers</URI>
      </Grantee>
      <Permission xmlns="">READ</Permission>
    </Grant>
    <Grant>
      <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="Group">
        <URI xmlns="">http://acs.petabox.io/groups/s3/LogDelivery</URI>
      </Grantee>
      <Permission xmlns="">WRITE</Permission>
    </Grant>
    <Grant>
      <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="AmazonCustomerByEmail">
        <EmailAddress xmlns="">xyz@petabox.io</EmailAddress>
      </Grantee>
      <Permission xmlns="">WRITE_ACP</Permission>
    </Grant>
    <Grant>
      <Grantee xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="CanonicalUser">
        <ID xmlns="">f30716ab7115dcb44a5ef76e9d74b8e20567f63TestAccountCanonicalUserID</ID>
      </Grantee>
      <Permission xmlns="">READ_ACP</Permission>
    </Grant>
  </AccessControlList>
</AccessControlPolicy>        
```

### Sample Response <a href="#api_putbucketacl_example_2" id="api_putbucketacl_example_2"></a>

This example illustrates one usage of PutBucketAcl.

```http
HTTP/1.1 200 OK
x-amz-id-2: NxqO3PNiMHXXGwjgv15LLgUoAmPVmG0xtZw2sxePXLhpIvcyouXDrcQUaWWXcOK0
x-amz-request-id: C651BC9B4E1BD401
Date: Thu, 12 Apr 2012 20:04:28 GMT
Content-Length: 0
Server: Petabox       
```

### Sample Request: Access permissions specified using headers <a href="#api_putbucketacl_example_3" id="api_putbucketacl_example_3"></a>

The following request uses ACL-specific request headers to grant the following permissions:

* Write permission to the Petabox`LogDelivery` group and a Petabox account identified by the email `xyz@example.com`.
* Read permission to the Petabox `AllUsers` group.

<pre class="language-http"><code class="lang-http">PUT ?acl HTTP/1.1
Host: examplebucket.s3.&#x3C;Region>.petabox.io
x-amz-date: Sun, 29 Apr 2012 22:00:57 GMT
x-amz-grant-write: uri="http://<a data-footnote-ref href="#user-content-fn-1">acs.petabox.io</a>/groups/s3/LogDelivery", emailAddress="xyz@petabox.io"
x-amz-grant-read: uri="http://acs.petabox.io/groups/global/AllUsers"
Accept: */*
Authorization: authorization string 
</code></pre>

### Sample Response <a href="#api_putbucketacl_example_4" id="api_putbucketacl_example_4"></a>

This example illustrates one usage of PutBucketAcl.

```http
HTTP/1.1 200 OK
x-amz-id-2: 0w9iImt23VF9s6QofOTDzelF7mrryz7d04Mw23FQCi4O205Zw28Zn+d340/RytoQ
x-amz-request-id: A6A8F01A38EC7138
Date: Sun, 29 Apr 2012 22:01:10 GMT
Content-Length: 0
Server: Petabox
```

[^1]:
